/* ------------------------------------------------------------------
 * Copyright (C) 1998-2009 PacketVideo
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 * -------------------------------------------------------------------
 */
/*

 Filename: e_mp4ff_const.h

------------------------------------------------------------------------------
 INCLUDE DESCRIPTION

 This file enums the constants used by MP4FF header

------------------------------------------------------------------------------
*/

/*----------------------------------------------------------------------------
; CONTINUE ONLY IF NOT ALREADY DEFINED
----------------------------------------------------------------------------*/
#ifndef E_MP4FF_CONST_H
#define E_MP4FF_CONST_H

/*----------------------------------------------------------------------------
; INCLUDES
----------------------------------------------------------------------------*/
#include    "pv_audio_type_defs.h"

/*----------------------------------------------------------------------------
; MACROS
; Define module specific macros here
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
; DEFINES
; Include all pre-processor statements here.
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
; EXTERNAL VARIABLES REFERENCES
; Declare variables used in this module but defined elsewhere
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
; SIMPLE TYPEDEF'S
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
; ENUMERATED TYPEDEF'S
----------------------------------------------------------------------------*/
typedef enum
{
    LEN_OBJ_TYPE = 5,
    LEN_SAMP_RATE_IDX = 4,
    LEN_SAMP_RATE   = 24,
    LEN_CHAN_CONFIG = 4,
    LEN_SYNC_EXTENSION_TYPE = 11,
    LEN_FRAME_LEN_FLAG = 1,
    LEN_DEPEND_ON_CORE = 1,
    LEN_CORE_DELAY = 14,
    LEN_EXT_FLAG = 1,
    LEN_EP_CONFIG = 2,
    LEN_LAYER_NUM = 3,
    LEN_SUB_FRAME = 5,
    LEN_LAYER_LEN = 11,
    LEN_SECT_RES_FLAG = 1,
    LEN_SCF_RES_FLAG = 1,
    LEN_SPEC_RES_FLAG = 1,
    LEN_EXT_FLAG3 = 1
} eMP4FF_const;

/*----------------------------------------------------------------------------
; STRUCTURES TYPEDEF'S
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
; GLOBAL FUNCTION DEFINITIONS
; Function Prototype declaration
----------------------------------------------------------------------------*/


/*----------------------------------------------------------------------------
; END
----------------------------------------------------------------------------*/
#endif


